import 'package:web_socket_channel/web_socket_channel.dart';

class WSClient {
    static final WSClient _client = WSClient();
    late WebSocketChannel _channel;

    void connect(String id) {
        _channel = WebSocketChannel.connect(Uri.parse("ws://skipdq.herokuapp.com"));
        // ping pong
        _pingPong(id);
    }

    void _pingPong(String id) async {
        // send user id to server
        _channel.sink.add("{"
            "\"message\": \"registerSocket\","
            "\"id\": \"$id\""
            "}");
        while(true) {
            // send ping every 30 sec
            _channel.sink.add("ping");
            await Future.delayed(Duration(seconds: 30));
        }
    }

    void listen(void Function(String) listener) => _channel.stream.listen((event) => listener(event));


    static WSClient getClient() => _client;
}